VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CBugFilter"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

'$ Uses BUGFILT.BAS

Const sBug = "Bug"
Const sProfile = "Profile"
Const sComment = "'"
Const sBugAssert = "BugAssert "
Private ordFilterType As Integer

' Every CFilter class must have a standard CFilter interface
''@B FilterInterface
'' Standard CFilter interface starts here

Public SourceFile As String, TargetFile As String

''@B DoFilter
Function DoFilter(sLine As String, ByVal iLine As Long) As Boolean

'' Standard CFilter interface ends here
''@E FilterInterface
    DoFilter = True     ' Always finish this filter
    
    Select Case ordFilterType
    Case ordDisableBug
        CommentOut sLine, sBug
    Case ordEnableBug
        CommentIn sLine, sBug
    Case ordDisableProfile
        CommentOut sLine, sProfile
    Case ordEnableProfile
        CommentIn sLine, sProfile
    Case ordExpandAsserts
        ExpandAsserts sLine, iLine
    Case ordTrimAsserts
        TrimAsserts sLine
    End Select
End Function
''@E DoFilter

''@B FilterType
Property Get FilterType() As Integer
    FilterType = ordFilterType
End Property

Property Let FilterType(ordFilterTypeA As Integer)
    If ordFilterTypeA > ordInvalid And _
       ordFilterTypeA <= ordMaxFilter Then
        ordFilterType = ordFilterTypeA
    Else
        ordFilterType = ordInvalid
    End If
End Property
''@E FilterType

Private Sub CommentOut(sLine As String, sTarget As String)
    
    ' Check to see if line contains target
    Dim iPos As Integer
    iPos = InStr(sLine, sTarget)
    If iPos Then
    
        ' If text is first nonblank, comment it out
        Dim s As String
        s = Space$(iPos - 1)
        If Left$(sLine, iPos - 1) = s Then
            sLine = s & sComment & Mid$(sLine, iPos)
        End If
    End If
            
End Sub

Private Sub CommentIn(sLine As String, sTarget As String)
    
    ' Check to see if line contains string
    Dim iPos As Integer
    iPos = InStr(sLine, sComment & sTarget)
    If iPos Then
    
        ' If text is first nonblank, comment it in
        Dim s As String
        s = Space$(iPos - 1)
        If Left$(sLine, iPos - 1) = s Then
            sLine = s & Mid$(sLine, iPos + 1)
        End If
    End If
            
End Sub

Private Sub ExpandAsserts(sLine As String, iLine As Long)
    
    Dim iPos As Integer, i As Integer, sComment As String
    ' Check to see if line contains Bug string
    iPos = InStr(sLine, sBugAssert)
    If iPos Then
    
        ' Save comment so it won't be processed
        i = InStr(sLine, "'")
        If i Then
            ' Ignore commented out Bug strings
            If iPos > i Then Exit Sub
            ' Remove comment
            sComment = Mid$(sLine, i)
            sLine = Left$(sLine, i - 1)
        End If
        ' Move to first argument
        iPos = iPos + Len(sBugAssert)
        
        ' If it already has a second argument, replace
        i = InStr(iPos, sLine, ",")
        If i Then sLine = Left$(sLine, i - 1)
            
        ' Add second argument
        Dim s As String
        s = Mid$(sLine, iPos)
        sLine = sLine & ", """ & s & ", file " & _
                SourceFile & ", line " & iLine & """"
        If sComment <> sEmpty Then sLine = sLine & " " & sComment
    End If
            
End Sub

Private Sub TrimAsserts(sLine As String)
    
    ' Check to see if line contains string
    Dim iPos As Integer, i As Integer, sComment As String
    iPos = InStr(sLine, sBugAssert)
    If iPos Then
    
        ' Save comment so it won't be processed
        i = InStr(sLine, "'")
        If i Then
            ' Ignore commented out Bug strings
            If iPos > i Then Exit Sub
            ' Remove comment
            sComment = Mid$(sLine, i)
            sLine = Left$(sLine, i - 1)
        End If
        ' Move to first argument
        iPos = iPos + Len(sBugAssert)
        
        ' Move to first argument
        iPos = iPos + Len(sBugAssert)
        
        ' Remove any second argument
        i = InStr(iPos, sLine, ",")
        If i Then sLine = Left$(sLine, i - 1)
        If sComment <> sEmpty Then sLine = sLine & sComment
            
    End If
            
End Sub
