/*
*   Visual Basic Callback Server Source
*
*   (c) Copyright Microsoft Corp. 1995 All Rights Reserved
*/ 

#include <windows.h>
#define IIDOK(A) IsEqualIID(riid, IID_##A)  //eg: IIDOK(IUnknown)
#define CLASS class FAR
#ifdef WIN32
	#define INC_OLE2
    #define EXPORT __declspec(dllexport)
	#include <oleauto.h>
	#include <objbase.h>
#else
	#define EXPORT _export
	#define LPWSTR LPSTR
	#include <ole2.h>
	#include <olenls.h>
	#include <compobj.h>
	#include <dispatch.h>
	#include <shellapi.h>
#endif
#include <olectl.h>

/*
The following macros can be used in order to use the same code for
WIN16, WIN32/OAU/UNICODE and WIN32/OAU preprocessor definitions.  Strings
are declare with the corrct type (Wide or MultiByte) and are converted correctly
to support both Windows and OLE2.0 API calls.

Macros:
OLECHAR: A character compatible with OLE API's.
LPOLESTR: A pointer to an string used by OLE API's
OLESTR(x): A constant string for use by OLE API's, eg OLESTR("foo")
SYSCHAR: A character compatible with Windows API's.
LPSYSSTR: A pointer to an string used by Windows API's
SYSSTR(x): A constant string for use by Windows API's, eg SYSSTR("foo")
SYSOLESTR(x): Convert an OLESTR to a SYSSTR	to use OLE strings with system API calls
OLESYSSTR(x): Convert an SYSSTR to a OLESTR to use system strings with OLE API calls
FREESTR(x): Free the temp strings created by OLESYSSTR and SYSOLESTR

Example use of macros:
	SYSCHAR szSysFileName[128];				  //Allocate a string buffer for a system call
	LPOLESTR lpOleFileName;					  //A string pointer for use in OLE calls
	GetModuleFileName(g_hinst, szSysFileName, 128);	 //A Windows API call
	lpOleFileName = OLESYSSTR(szSysFileName);  //Allocate a new converted string if necessary, copy the pointer if not
	LoadTypeLib(lpOleFileName, &ptlib);		   //An OLE API call
	FREESTR(lpOleFileName);					   //Free the string allocated by OLESYSSTR
*/
#ifdef OAU  //Always set for WIN32
#define OLECHAR   WCHAR
#define LPOLESTR  LPWSTR
#define OLESTR(x) L##x
#else 	
#define OLECHAR   char
#define LPOLESTR  LPSTR
#define OLESTR(x) x
#endif	


#ifdef UNICODE
#define SYSCHAR     WCHAR
#define LPSYSSTR    LPWSTR
#define SYSSTR(x)   L##x
#define SYSOLESTR(x) x
#define OLESYSSTR(x) x
#define FREESTR(x)
#else
#define SYSCHAR     char
#define LPSYSSTR    LPSTR
#define SYSSTR(x)   x
#ifdef OAU
//Implemented in HOSTENV.CPP
LPSYSSTR UNICODEtoANSI(BSTR bstrUNICODE);
BSTR ANSItoUNICODE(LPSYSSTR bstrANSI);
#define SYSOLESTR(x) UNICODEtoANSI(x)
#define OLESYSSTR(x) ANSItoUNICODE(x)
#define FREESTR(x)   SysFreeString((LPOLESTR)x)
#else
#define SYSOLESTR(x) x
#define OLESYSSTR(x) x
#define FREESTR(x)
#endif	
#endif	
                   
                   
