VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CDrive"
Attribute VB_Creatable = True
Attribute VB_Exposed = False
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

'$ Uses DRIVE.BAS UTILITY.BAS

''@B PrivateDrive
Private sRoot As String
Private iDrive As Integer
Private ordType As Integer
Private iTotalClusters As Long
Private iFreeClusters As Long
Private iSectors As Long
Private iBytes As Long
Private sLabel As String
''@E PrivateDrive

Const iAscA = 65

''@B GetDriveInfo
Public Property Get TotalBytes() As Single
    If sRoot = sEmpty Then
        TotalBytes = -1
    Else
        TotalBytes = CSng(iTotalClusters) * iSectors * iBytes
    End If
End Property

Public Property Get FreeBytes() As Single
    If sRoot = sEmpty Then
        FreeBytes = -1
    Else
        FreeBytes = CSng(iFreeClusters) * iSectors * iBytes
    End If
End Property

Public Property Get Label() As String
    If sRoot <> sEmpty Then Label = sLabel
    ' Else Label = sEmpty
End Property

Public Property Get Kind() As Integer
    Kind = ordType
End Property

Public Property Get KindStr() As String
    If sRoot = sEmpty Then Exit Property
    KindStr = Choose(ordType + 1, "Unknown", "Invalid", "Floppy", _
                                  "Hard", "Network", "CD-ROM", "RAM")
    ' Floppy or CD-ROM of size 0 means disk is missing
    If (ordType = 2 Or ordType = 5) And iTotalClusters = 0 Then
        KindStr = KindStr & " Missing"
    End If
End Property
''@E GetDriveInfo

Public Property Get Error() As Integer
    Error = IIf(Err, Err - vbObjectError, 0)
End Property

''@B GetRoot
Public Property Get Root() As String
    Root = sRoot
End Property
''@E GetRoot

''@B LetRoot
Public Property Let Root(sRootA As String)
    ' Assume failure
    sRoot = sEmpty: sLabel = sEmpty
    iSectors = 0: iBytes = 0
    iFreeClusters = 0: iTotalClusters = 0
    ' Empty means get current drive
    If sRootA = sEmpty Then sRootA = Left$(CurDir$, 3)
    ' Get drive type ordinal
    ordType = GetDriveType(sRootA)
    Select Case ordType
    Case 1
        ' Invalid root, ignore (set root to sEmpty)
    Case 0
        ' No such drive, ignore (set root to sEmpty)
    Case 2 To 6 ' Unknown, removable, fixed, remote, CD-ROM, RAM
        ' If you got here, drive is valid
        sRoot = UCase$(sRootA)
        iDrive = Asc(sRoot) - iAscA + 1
        ' Network drives have no number
        If ordType = 4 Then iDrive = 0
        ' Get disk size
        If GetDiskFreeSpace(sRoot, iSectors, iBytes, _
                            iFreeClusters, iTotalClusters) Then
            ' Failure might simply indicate empty floppy or CD drive
            ' or network drive that can't be sized under Win16;
            ' either way, you can't get label
            sLabel = GetLabel(sRoot)
        End If
    Case Else ' Shouldn't happen
        BugAssert True
    End Select
End Property
''@E LetRoot

''@B GetNumber
Public Property Get Number() As Integer
    If sRoot = sEmpty Then
        Number = -1
    Else
        Number = iDrive
    End If
End Property
''@E GetNumber

''@B LetNumber
Public Property Let Number(iDriveA As Integer)
    Select Case iDriveA
    Case 1 To 26
        ' Create root
        Root = Chr$(iDriveA + iAscA - 1) & ":\"
    Case 0
        ' Get current drive and create root
        Root = Left$(CurDir$, 3)
    Case Else
        ' Invalid root, set root to sEmpty
        sRoot = sEmpty
    End Select
End Property
''@E LetNumber

''@B Refresh
Public Sub Refresh()
    Root = sRoot
End Sub
''@E Refresh
'
