Attribute VB_Name = "MInstTool"
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

'$ Uses UTILITY.BAS DEBUG.BAS WINTOOL.BAS WINTYPE.BAS

''@B TTaskEntry
Type TTaskEntry
    dwSize As Long
    hTask As Integer
    hTaskParent As Integer
    hInst As Integer
    hModule As Integer
    wSS As Integer
    wSP As Integer
    wStackTop As Integer
    wStackMinimum As Integer
    wStackBottom As Integer
    wcEvents As Integer
    hQueue As Integer
    szModule As String * 10
    wPSPOffset As Integer
    hNext As Integer
End Type
''@E TTaskEntry

''@B TModuleEntry
Type TModuleEntry
    dwSize As Long
    szModule As String * 10
    hModule As Integer
    wcUsage As Integer
    szExePath As String * 256
    wNext As Integer
End Type
''@E TModuleEntry

Type TProcessInformation
    hProcess As Long
    hThread As Long
    dwProcessID As Long
    dwThreadID As Long
End Type

Type TStartupInfo
    cb As Long
    lpReserved As String
    lpDesktop As String
    lpTitle As String
    dwX As Long
    dwY As Long
    dwXSize As Long
    dwYSize As Long
    dwXCountChars As Long
    dwYCountChars As Long
    dwFillAttribute As Long
    dwFlags As Long
    wShowWindow As Integer
    cbReserved2 As Integer
    lpReserved2 As Long
    hStdInput As Long
    hStdOutput As Long
    hStdError As Long
End Type

#If Win32 Then
Public Const STARTF_USESHOWWINDOW = &H1
Public Const STARTF_USESIZE = &H2
Public Const STARTF_USEPOSITION = &H4
Public Const STARTF_USECOUNTCHARS = &H8
Public Const STARTF_USEFILLATTRIBUTE = &H10
Public Const STARTF_RUNFULLSCREEN = &H20

Public Const STARTF_FORCEONFEEDBACK = &H40
Public Const STARTF_FORCEOFFFEEDBACK = &H80
Public Const STARTF_USESTDHANDLES = &H100
Public Const STARTF_USEHOTKEY = &H200

Declare Function CreateProcess Lib "KERNEL32" Alias "CreateProcessA" _
    (ByVal lpApplicationName As String, ByVal lpCommandLine As String, _
    ByVal lpProcessAttributes As Long, ByVal lpThreadAttributes As Long, _
    ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, _
    ByVal lpEnvironment As Long, ByVal lpCurrentDirectory As String, _
    lpStartupInfo As TStartupInfo, lpProcessInformation As TProcessInformation) As Long

#End If

#If Win32 = 0 Then

Declare Function ModuleFirst Lib "TOOLHELP.DLL" (module As TModuleEntry) As Integer
Declare Function ModuleNext Lib "TOOLHELP.DLL" (module As TModuleEntry) As Integer
Declare Function ModuleFindName Lib "TOOLHELP.DLL" (module As TModuleEntry, _
    ByVal sName As String) As Integer
Declare Function ModuleFindHandle Lib "TOOLHELP.DLL" (module As TModuleEntry, _
    ByVal hMod As Integer) As Integer
Declare Function TaskFirst Lib "TOOLHELP.DLL" (task As TTaskEntry) As Integer
Declare Function TaskNext Lib "TOOLHELP.DLL" (task As TTaskEntry) As Integer
Declare Function TaskFindHandle Lib "TOOLHELP.DLL" (task As TTaskEntry, _
    ByVal hTask As Integer) As Integer

''@B ExeFromModuleName
Function ExeFromModuleName(sModuleName As String) As String
    Dim module As TModuleEntry
    Dim c As Integer, hInst As Long

    module.dwSize = Len(module)
    hInst = ModuleFindName(module, sModuleName)
    BugAssert hInst <> hNull
    c = InStr(module.szExePath, sNullChr)
    BugAssert c > 0
    ExeFromModuleName = GetFileBaseExt(Left$(module.szExePath, c - 1))

End Function
''@E ExeFromModuleName

''@B ModuleFromExeName
Function ModuleFromExeName(sExe As String) As String

    BugAssert sExe <> sEmpty
    
    
    Dim f As Integer, i As Integer, sExeNew As String
    Dim module As TModuleEntry
    module.dwSize = Len(module)
    f = ModuleFirst(module)
    Do While f

        i = InStr(module.szExePath, sNullChr)
        BugAssert i > 0
        sExeNew = GetFileBaseExt(Left$(module.szExePath, i - 1))

        If StrComp(sExe, sExeNew, 0) = 0 Then
            i = InStr(module.szModule, sNullChr)
            BugAssert i > 0
            ModuleFromExeName = Left$(module.szModule, i - 1)
            Exit Function
        End If
        f = ModuleNext(module)

    Loop
    ModuleFromExeName = sEmpty
        
End Function
''@E ModuleFromExeName

Function TaskFromInst(hInst As Integer) As Integer
    Dim task As TTaskEntry, f As Boolean
    task.dwSize = Len(task)
    f = TaskFirst(task)
    Do While f
        If task.hInst = hInst Then
            TaskFromInst = task.hTask
            Exit Function
        End If
        f = TaskNext(task)
    Loop
    ' TaskFromInst = hNull
End Function
#End If ' Win32

''@B GetInstModule
Function GetInstModule(hInst) As String
#If Win32 Then
    Dim s As String
    s = GetInstExeName(hInst)
    If s <> sEmpty Then
        s = Left$(s, GetExtPos(s))
    End If
    GetInstModule = s
#Else
    Dim module As TModuleEntry
    Dim hMod As Long, c As Integer
    GetInstModule = sEmpty
    module.dwSize = Len(module)
    hMod = ModuleFindHandle(module, hInst)
    c = InStr(module.szModule, sNullChr)
    If c Then
        GetInstModule = Left$(module.szModule, c - 1)
    End If
#End If
End Function
''@E GetInstModule

''@B GetWndModName
Function GetWndModName(ByVal hWnd) As String
#If Win32 Then
    GetWndModName = GetWndExeName(hWnd)
#Else
    BugAssert hWnd <> hNull
    Dim f As Boolean, c As Integer
    Dim task As TTaskEntry, hTask ' As SysInt
    hTask = GetWindowTask(hWnd)
    task.dwSize = Len(task)
    f = TaskFindHandle(task, hTask)
    BugAssert f
    c = InStr(task.szModule, sNullChr)
    If c Then
        GetWndModName = Left$(task.szModule, c - 1)
    End If
#End If
End Function
''@E GetWndModName

''@B FindInstanceInfo1
Sub FindInstanceInfo(Optional vTopWnd As Variant, _
                     Optional vInst As Variant, _
                     Optional vExe As Variant, _
                     Optional vTitle As Variant, _
                     Optional vClass As Variant)
''@E FindInstanceInfo1
    Dim hTopWnd As Long, hInst As Long
    hTopWnd = vTopWnd
    hInst = vInst

    ''@B FindInstanceInfo2
    Dim hWnd As Long, hInstCur As Long
    If hTopWnd <> hNull Then

        BugMessage "FindInstanceInfo: Window"
        hWnd = hTopWnd
        hInst = hNull
        vExe = Empty
        vTitle = Empty
        vClass = Empty
    ''@E FindInstanceInfo2

    ''@B FindInstanceInfo3
    ElseIf hInst <> hNull Then

        BugMessage "FindInstanceInfo: Instance"
        vExe = Empty
        vTitle = Empty
        vClass = Empty

        ' Get first window
        hWnd = GetWindow(GetDesktopWindow(), GW_CHILD)

        Do While hWnd <> hNull

            ' Check instance until it matches
            hInstCur = GetWindowData(hWnd, GWD_HINSTANCE)
            If hInst = hInstCur Then
                If IsWindowVisible(hWnd) Then Exit Do
            End If

            ' Get next sibling
            hWnd = GetWindow(hWnd, GW_HWNDNEXT)
        
        Loop
    ''@E FindInstanceInfo3

    ''@B FindInstanceInfo4
    ElseIf vExe <> Empty Then

        BugMessage "FindInstanceInfo: ExeName"
        vTitle = Empty
        vClass = Empty

        ' Loop through for matching exe name
        hWnd = GetWindow(GetDesktopWindow(), GW_CHILD)
        Dim sExeCur As String

        Do
            ' If no match, instance is invalid or DLL
            If hWnd = hNull Then
#If Win32 = 0 Then
                ' Get an hInst
                Dim module As TModuleEntry
                module.dwSize = Len(module)
                sExeCur = vExe
                ' Technically we're returning module handle, not instance
                vInst = ModuleFindName(module, ModuleFromExeName(sExeCur))
#End If
                Exit Sub
            End If

            ' Check module until it matches
            hInstCur = GetWindowData(hWnd, GWD_HINSTANCE)
            sExeCur = GetInstExeName(hInstCur)

            ' Check base name, case insensitive
            If StrComp(vExe, sExeCur, 1) = 0 Then
                ' Some users might prefer to add visibility check
                'If IsWindowVisible(hWnd) Then
                    hInst = hInstCur
                    Exit Do
                'End If
            End If

            ' Get next sibling
            hWnd = GetWindow(hWnd, GW_HWNDNEXT)
        
        Loop
    ''@E FindInstanceInfo4

    ''@B FindInstanceInfo5
    ElseIf vTitle <> Empty Then
        If vClass = Empty Then
            BugMessage "FindInstanceInfo: Title"
            hWnd = FindWindow(vbNullString, vTitle)
        Else
            BugMessage "FindInstanceInfo: Title and Class"
            hWnd = FindWindow(vTitle, vClass)
        End If

    ElseIf vClass <> Empty Then
            BugMessage "FindInstanceInfo: Class"
            hWnd = FindWindow(vClass, vbNullString)
    ''@E FindInstanceInfo5

    Else
        BugMessage "FindInstanceInfo: Invalid input"
        Exit Sub

    End If

    ''@B FindInstanceInfo6
    ' Get instance and name
    If hInst = hNull Then hInst = GetWindowData(hWnd, GWD_HINSTANCE)
    If hInst = hNull Then Exit Sub
    If vExe = Empty Then vExe = GetInstExeName(hInst)
    If hWnd <> hNull Then

        ' Get owner in case top level window is dialog
        hTopWnd = GetWindow(hWnd, GW_OWNER)
        If hTopWnd = hNull Then hTopWnd = hWnd

        ' Get title and class
        If vClass = Empty Then vClass = VBGetClassName(hTopWnd)
        If vTitle = Empty Then vTitle = VBGetWindowTextLine(hTopWnd)
    Else
        hTopWnd = hNull
    End If
    vTopWnd = hTopWnd
    vInst = hInst

End Sub
''@E FindInstanceInfo6

''@B Signatures
Function GetSigMod(hWnd) As Long
#If Win32 Then
    GetSigMod = GetWindowData(hWnd, GWD_HINSTANCE)
#Else
    Dim f As Boolean, task As TTaskEntry, hTask ' As SysInt
    hTask = GetWindowTask(hWnd)
    task.dwSize = Len(task)
    f = TaskFindHandle(task, hTask)
    BugAssert f
    GetSigMod = task.hModule
#End If
End Function

Function GetSigProc(hWnd) As Long
#If Win32 Then
    Dim id As Long
    Call GetWindowThreadProcessId(hWnd, id)
    GetSigProc = id
#Else
    GetSigProc = GetWindowTask(hWnd)
#End If
End Function
''@E Signatures

' Don't build for DLLs
#If fDLL = 0 Then
''@B ActivatePrevInstance
Sub ActivatePrevInstance(frm As Form)
    ' Comment out next line to debug in environment
    If App.PrevInstance = False Then Exit Sub
    Dim hWndYou ' As SysInt
    Dim sigModYou As Long, sigModMe As Long
    Dim sigProcYou As Long, sigProcMe As Long
    
    ' Get my own instance handle and executable name
    sigModMe = GetSigMod(frm.hWnd)
    sigProcMe = GetSigProc(frm.hWnd)
    ' Get first sibling to start iterating top level windows
    hWndYou = GetWindow(frm.hWnd, GW_HWNDFIRST)
    Do While hWndYou <> hNull
        ' Get instance handle and module name of window
        sigModYou = GetSigMod(hWndYou)
        sigProcYou = GetSigProc(hWndYou)
        ' Activate if module same, but process different
        If (sigModMe = sigModYou) And (sigProcMe <> sigProcYou) Then
            ' Do something more complicated here if you want
            AppActivate hWndYou
            End
        End If
        ' Get next sibling
        hWndYou = GetWindow(hWndYou, GW_HWNDNEXT)
    Loop
End Sub
''@E ActivatePrevInstance
#End If

' Pass idProg returned by Shell or ShellPlus
''@B IsRunning
Function IsRunning(idProg) As Boolean ' SysInt parameter
#If Win32 Then
    Dim hProc As Long, iRet As Long
    ' Get process handle
    hProc = OpenProcess(PROCESS_QUERY_INFORMATION, False, idProg)
    ' Check status of process
    If hProc <> hNull Then GetExitCodeProcess hProc, iRet
    IsRunning = (iRet = STILL_ACTIVE)
    CloseHandle hProc
#Else
    IsRunning = TaskFromInst(idProg)
#End If
End Function
''@E IsRunning

''@B WaitOnProgram
Sub WaitOnProgram(idProg) ' SysInt parameter
#If Win32 Then
    ' Get process handle
    Dim hProc As Long, iRet As Long
    hProc = OpenProcess(PROCESS_ALL_ACCESS, False, idProg)
    ' Wait until process terminates
    If hProc <> hNull Then
        iRet = WaitForSingleObject(hProc, INFINITE)
        CloseHandle hProc
    End If
#Else
    Do While TaskFromInst(idProg)
        DoEvents
    Loop
#End If
End Sub
''@E WaitOnProgram

#If Win32 Then
Function ShellPlus(sPathName As String, _
                   Optional vShow As Variant, _
                   Optional vWait As Variant, _
                   Optional vInitDir As Variant, _
                   Optional vTitle As Variant, _
                   Optional vx As Variant, Optional vy As Variant, _
                   Optional vdx As Variant, Optional vdy As Variant, _
                   Optional vCols As Variant, Optional vRows As Variant, _
                   Optional vColor As Variant, _
                   Optional vFullScreen As Variant) As Long
                   
    Dim proc As TProcessInformation, start As TStartupInfo
    Dim fWait As Boolean, atrColor As Long
    atrColor = &HFF00   ' White on Black
With start
    .cb = Len(start)
    If Not IsMissing(vWait) Then fWait = vWait ' Else False
    If IsMissing(vInitDir) Then vInitDir = vbNullString
    If vInitDir = Empty Then vInitDir = vbNullString
    If Not IsMissing(vShow) Then
        .wShowWindow = vShow
        .dwFlags = .dwFlags Or STARTF_USESHOWWINDOW
    End If
    If Not IsMissing(vTitle) Then .lpTitle = vTitle
    If Not IsMissing(vx) Then
        .dwX = vx
        .dwFlags = .dwFlags Or STARTF_USEPOSITION
    End If
    If Not IsMissing(vy) Then
        .dwY = vy
        .dwFlags = .dwFlags Or STARTF_USEPOSITION
    End If
    If Not IsMissing(vdx) Then
        .dwXSize = Val(vdx)
        If .dwXSize > 0 Then .dwFlags = .dwFlags Or STARTF_USESIZE
    End If
    If Not IsMissing(vdy) Then
        .dwYSize = Val(vdy)
        If .dwYSize > 0 Then .dwFlags = .dwFlags Or STARTF_USESIZE
    End If
    If Not IsMissing(vCols) Then
        .dwXCountChars = vCols
        .dwFlags = .dwFlags Or STARTF_USECOUNTCHARS
    End If
    If Not IsMissing(vRows) Then
        .dwYCountChars = vRows
        .dwFlags = .dwFlags Or STARTF_USECOUNTCHARS
    End If
    If Not IsMissing(vColor) Then
        .dwFillAttribute = vColor
        .dwFlags = .dwFlags Or STARTF_USEFILLATTRIBUTE
    End If
    If Not IsMissing(vFullScreen) And vFullScreen Then
        .dwFlags = .dwFlags Or STARTF_RUNFULLSCREEN
    End If
End With

    ''@B CreateProcess
    ' Create process and run it
    If CreateProcess(sNullStr, sPathName, pNull, pNull, False, _
                     0&, pNull, vInitDir, start, proc) Then
        ShellPlus = proc.dwProcessID
        If fWait Then WaitOnProgram (proc.dwProcessID)
        CloseHandle proc.hProcess
        CloseHandle proc.hThread
    End If
    ''@E CreateProcess
    
End Function

Function ColorAttr(atrFore As Long, atrBack As Long)
    ColorAttr = LShiftWord((&HF And atrBack), 4) Or (&HF And atrFore)
End Function

#End If ' Win32

Function VBShellExecute(sFile As String, _
                        Optional vArgs As Variant, _
                        Optional vShow As Variant, _
                        Optional vInitDir As Variant, _
                        Optional vVerb As Variant, _
                        Optional vhWnd As Variant) As Long
    If IsMissing(vArgs) Then vArgs = vbNullString
    If IsMissing(vShow) Then vShow = vbNormalFocus
    If IsMissing(vInitDir) Then vInitDir = vbNullString
    If IsMissing(vVerb) Then vVerb = vbNullString
    If IsMissing(vhWnd) Then vhWnd = hNull
    VBShellExecute = ShellExecute(vhWnd, vVerb, sFile, _
                                  vArgs, vInitDir, vShow)
    
End Function

