Attribute VB_Name = "MMenuTool"
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

'$ Uses PARSE.BAS

''@B SyncMenu
Sub SyncMenu(hMenuMe, hMenuYou)
    Dim cItemMe As Integer, i As Integer
    Dim idMe As Integer, idYou As Integer
    Dim afMe As Integer, afYou As Integer
    'Dim sMe As String, sYou As String
    Dim c As Integer

    ' If we can't get handle of real menu,
    ' gray everything on fake
    cItemMe = GetMenuItemCount(hMenuMe)
    If hMenuYou = hNull Then
        For i = 0 To cItemMe
            idMe = GetMenuItemID(hMenuMe, i)
            c = EnableMenuItem(hMenuMe, idMe, MF_BYCOMMAND Or MF_DISABLED)
            c = EnableMenuItem(hMenuMe, idMe, MF_BYCOMMAND Or MF_GRAYED)
            If idMe = -1 Then SyncMenu GetSubMenu(hMenuMe, i), hNull
        Next
        Exit Sub
    End If
                
    ' Synchronize real and fake menus
    For i = 0 To cItemMe
        idMe = GetMenuItemID(hMenuMe, i)
        idYou = GetMenuItemID(hMenuYou, i)
        afMe = GetMenuState(hMenuMe, i, MF_BYPOSITION)
        afYou = GetMenuState(hMenuYou, i, MF_BYPOSITION)
        If idMe = -1 Then SyncMenu GetSubMenu(hMenuMe, i), GetSubMenu(hMenuYou, i)
        Dim f As Integer
        If idMe = idYou Then
            If afYou And MF_CHECKED Then
                f = CheckMenuItem(hMenuMe, idMe, MF_BYCOMMAND Or MF_CHECKED)
            Else
                f = CheckMenuItem(hMenuMe, idMe, MF_BYCOMMAND Or MF_UNCHECKED)
            End If
            If afYou And MF_DISABLED Then
                f = EnableMenuItem(hMenuMe, idMe, MF_BYCOMMAND Or MF_DISABLED)
            Else
                f = EnableMenuItem(hMenuMe, idMe, MF_BYCOMMAND Or MF_ENABLED)
            End If
            If afYou And MF_GRAYED Then
                f = EnableMenuItem(hMenuMe, idMe, MF_BYCOMMAND Or MF_GRAYED)
            End If
        End If
    Next

End Sub
''@E SyncMenu

#If 0 Then
''@B DoMenuItem
Function DoMenuItem(ByVal hWnd, sItem As String) As Boolean
    ' Assume failure for easy exit
    DoMenuItem = False

    Dim hMenu ' As SysInt
    Dim f As Long
    hMenu = GetMenu(hWnd)
    If hMenu = hNull Then Exit Function

    ' Get ID
    Dim idMenuItem As Integer
    idMenuItem = FindMenuItemID(hMenu, sItem)

    ' Execute command
    If idMenuItem >= 0 Then
        f = SendMessageAsLong(hWnd, WM_COMMAND, idMenuItem, 0&)
        If f = False Then DoMenuItem = True
    End If
End Function
''@E DoMenuItem

''@B DoWinMenuItem
Function DoWinMenuItem(sClass As String, sTitle As String, _
                       sItem As String) As Boolean
    ' Assume failure for easy exit
    DoWinMenuItem = False
    
    ' Find application
    Dim hWnd
    hWnd = VBFindTopWindow(sClass, sTitle)
    If hWnd = hNull Then Exit Function
    ' Get menu handle
    DoWinMenuItem = DoMenuItem(hWnd, sItem)

End Function
''@E DoWinMenuItem

''@B FindMenuItemID
Function FindMenuItemID(ByVal hMenu, sItem As String) As Integer
    Dim sItem1 As String, sItem2 As String, sItem3 As String
    Dim sSep As String, ID As Long
    
    ' Parse item into up to three parts
    sSep = "."
    sItem1 = GetToken(sItem, sSep)
    sItem2 = GetToken(sEmpty, sSep)
    sItem3 = GetToken(sEmpty, sSep)

    If sItem2 = sEmpty Then
        ' Recurse through menu levels to find match
        ID = FindSingleItemID(hMenu, sItem1)
    Else
        ' Find match for first level
        ID = FindNestedItemID(hMenu, sItem1)
        ' Match must be second level
        If ID = -1 Then
            ' Find match for second level
            ID = FindNestedItemID(hMenu, sItem2)
            ' If level three required, this must be submenu
            If sItem3 <> sEmpty Then
                If ID = -1 Then
                    ID = FindNestedItemID(hMenu, sItem3)
                Else
                    ID = -1
                End If
            End If
        Else
            ID = -1
        End If
    End If
    FindMenuItemID = ID
    
End Function
''@E FindMenuItemID

''@B FindNestedItemID
Function FindNestedItemID(hMenu, sItem As String) As Integer
    Dim ID As Integer, i As Integer, s As String
    ' Assume not found
    FindNestedItemID = -1
    
    ' Look for matching item name
    For i = 0 To GetMenuItemCount(hMenu) - 1
        ID = GetMenuItemID(hMenu, i)
        s = GetItemString(hMenu, i)
        ' Check for matching string
        If s Like sItem Then
            FindNestedItemID = ID
            ' If submenu, pass handle back through pointer
            If ID = -1 Then hMenu = GetSubMenu(hMenu, i)
            Exit For
        End If
    Next

End Function
''@E FindNestedItemID

''@B FindSingleItemID
Function FindSingleItemID(ByVal hMenu, sItem As String) As Integer
    Dim cItem As Integer, ID As Integer, i As Integer, s As String

    ' Look for matching item name
    cItem = GetMenuItemCount(hMenu)
    For i = 0 To cItem - 1
        ID = GetMenuItemID(hMenu, i)
        s = GetItemString(hMenu, i)
        If ID = -1 Then
            ' Call recursively to get next level
            ID = FindSingleItemID(GetSubMenu(hMenu, i), sItem)
            ' Get out if we found it
            If ID >= 0 Then Exit For
        End If
        ' Get out and fall through recursion if item found
        If s Like sItem Then Exit For
    Next
    If i = cItem Then ID = -1
    FindSingleItemID = ID

End Function
''@E FindSingleItemID

Function GetItemString(hMenu, iPos As Integer) As String
    Dim s As String, c As Integer, i As Integer
    s = Space$(81)
    c = GetMenuString(hMenu, iPos, s, 80, MF_BYPOSITION)
    ' Strip out any & character
    Dim sCur As String, sT As String
    For i = 1 To c
        sCur = Mid$(s, i, 1)
        If sCur <> "&" Then sT = sT & sCur
    Next
    GetItemString = sT
End Function

#End If
