Attribute VB_Name = "MRunMenu"
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

''@B Main
Sub Main()
    ' Convert command line to strings
    Dim sItem As String, sClass As String, sTitle As String
    ParseMenuCmd Command$, sClass, sTitle, sItem

    ' Find window handle
    Dim hWnd As Long
    hWnd = VBFindTopWindow(sClass, sTitle)
    If hWnd = hNull Then ErrorExit
    
    ' Find menu item
    Dim menu As New CMenuList, ritem As CMenuItem
    If Not menu.Create(hWnd) Then ErrorExit
    If Not menu.Find(sItem, ritem) Then ErrorExit
    If Not ritem.Execute Then ErrorExit
End Sub
''@E Main

' Error exit is structured way to exit
Sub ErrorExit()
    Beep
    ' End instead of Unload Me because no form to unload
    End
End Sub

Sub ParseMenuCmd(sCmd As String, sClass As String, _
                 sTitle As String, sItem As String)
    Dim sSep As String, i As Integer, s As String
    Static sTokens(1 To 6) As String
    
    sSep = " ," & sTab
    i = 1

    ' Put tokens in array of strings
    sTokens(i) = GetQToken(sCmd, sSep)
    Do While (sTokens(i) <> sEmpty) And (i <= 6)
        ' Strip off / or -
        s = Left$(sTokens(i), 1)
        If ((s = "/") Or (s = "-")) And (Len(sTokens(i)) > 2) Then
            sTokens(i + 1) = Mid$(sTokens(i), 3)
            sTokens(i) = Left$(sTokens(i), 2)
            i = i + 1
        End If
        i = i + 1
        sTokens(i) = GetQToken(sEmpty, sSep)
    Loop

    ' Get class, title, and item out of array
    For i = 1 To 6 Step 2
        Select Case UCase$(sTokens(i))
        Case "/C", "-C"
            sClass = sTokens(i + 1)
        Case "/T", "-T"
            sTitle = sTokens(i + 1)
        Case "/I", "-I"
            sItem = sTokens(i + 1)
        Case sEmpty
            Exit For
        End Select
    Next

End Sub
