VERSION 4.00
Begin VB.Form FSieve 
   Caption         =   "Sieve of Eratosthenes Client"
   ClientHeight    =   3240
   ClientLeft      =   1290
   ClientTop       =   1665
   ClientWidth     =   5340
   Height          =   3645
   Icon            =   "SIEVECLI.frx":0000
   Left            =   1230
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   3240
   ScaleWidth      =   5340
   Top             =   1320
   Width           =   5460
   Begin VB.ComboBox cboServer 
      Height          =   300
      ItemData        =   "SIEVECLI.frx":030A
      Left            =   2880
      List            =   "SIEVECLI.frx":0317
      Style           =   2  'Dropdown List
      TabIndex        =   14
      Top             =   2040
      Width           =   1095
   End
   Begin VB.CheckBox chkAll 
      Caption         =   "Get All"
      Height          =   255
      Left            =   2880
      TabIndex        =   13
      Top             =   2895
      Width           =   975
   End
   Begin VB.CheckBox chkLate 
      Caption         =   "Late Bind"
      Height          =   255
      Left            =   2880
      TabIndex        =   12
      Top             =   2655
      Width           =   975
   End
   Begin VB.ListBox lstOutput 
      Height          =   2760
      Left            =   4200
      TabIndex        =   11
      Top             =   120
      Width           =   975
   End
   Begin VB.CheckBox chkDisplay 
      Caption         =   "Display"
      Height          =   255
      Left            =   2880
      TabIndex        =   10
      Top             =   2400
      Width           =   975
   End
   Begin VB.TextBox txtTime 
      Height          =   375
      Left            =   2880
      TabIndex        =   8
      Top             =   1560
      Width           =   1095
   End
   Begin VB.TextBox txtPrimes 
      Height          =   375
      Left            =   2880
      TabIndex        =   6
      Top             =   1080
      Width           =   1095
   End
   Begin VB.TextBox txtMaxPrime 
      Height          =   375
      Left            =   2880
      TabIndex        =   3
      Text            =   " 5000"
      Top             =   600
      Width           =   1095
   End
   Begin VB.TextBox txtIterate 
      Height          =   375
      Left            =   2880
      TabIndex        =   2
      Text            =   "2"
      Top             =   120
      Width           =   1095
   End
   Begin VB.CommandButton cmdExit 
      Cancel          =   -1  'True
      Caption         =   "E&xit"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   1215
   End
   Begin VB.CommandButton cmdSieve 
      Caption         =   "&Sieve"
      Default         =   -1  'True
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label lbl 
      Caption         =   "Time:"
      Height          =   375
      Index           =   3
      Left            =   1560
      TabIndex        =   9
      Top             =   1560
      Width           =   1215
   End
   Begin VB.Label lbl 
      Caption         =   "Primes:"
      Height          =   375
      Index           =   2
      Left            =   1560
      TabIndex        =   7
      Top             =   1080
      Width           =   1215
   End
   Begin VB.Label lbl 
      Caption         =   "Maximum Prime:"
      Height          =   375
      Index           =   1
      Left            =   1560
      TabIndex        =   5
      Top             =   600
      Width           =   1215
   End
   Begin VB.Label lbl 
      Caption         =   "Iterations:"
      Height          =   375
      Index           =   0
      Left            =   1560
      TabIndex        =   4
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "FSieve"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Const ordBasicEXE = 0
Const ordBasicDll = 1
Const ordCppDll = 2

Private fDisplay As Boolean
Private dx As Long, dxOut As Long

Private Sub Form_Load()
    cboServer.Text = cboServer.List(0)
    dxOut = lstOutput.Left + Width - ScaleWidth
    dx = Width
    Width = dxOut
End Sub

Private Sub cboServer_Click()
#If Win32 = False Then
    If cboServer.ListIndex = ordBasicDll Then
        cmdSieve.Enabled = False
        cmdSieve.Caption = "No 16-bit DLL"
    Else
        cmdSieve.Enabled = True
        cmdSieve.Caption = "&Sieve"
    End If
#End If
End Sub

Private Sub chkDisplay_Click()
    Static cLastIter As Integer
    If cLastIter = 0 Then cLastIter = txtIterate.Text
    fDisplay = (chkDisplay.Value = vbChecked)
    If fDisplay Then
        txtIterate.Text = 1
        Width = dx
    Else
        txtIterate.Text = cLastIter
        Width = dxOut
    End If
End Sub

Private Sub cmdExit_Click()
    Unload Me
End Sub

Private Sub cmdSieve_Click()
    Dim ms As Long, i As Integer, iPrime As Integer, ai() As Integer
       
    ' Initialize prime variables
    Dim iMaxPrime As Integer, cIter As Integer, cPrime As Integer
    iMaxPrime = txtMaxPrime.Text
    cIter = txtIterate.Text
    cPrime = txtMaxPrime.Text
    txtTime.Text = sEmpty
    txtPrimes.Text = sEmpty
    
    Dim ordMouse As Integer
    ordMouse = MousePointer
    MousePointer = vbHourglass
    
    ' Default early binding
    If chkLate = vbUnchecked Then
        Select Case cboServer.ListIndex
        Case ordBasicEXE
            ' Basic EXE version, early bind
            ''@B NewCSieve
            Dim siv As New CSieve
            siv.MaxPrime = txtMaxPrime.Text
            ''@E NewCSieve...
            If chkAll = vbUnchecked Then
                ' Get one at a time
                ms = timeGetTime()
                For i = 1 To cIter
                    siv.ReInitialize
                    Do
                        iPrime = siv.NextPrime
                        If fDisplay And iPrime Then
                            lstOutput.AddItem iPrime
                            lstOutput.TopIndex = lstOutput.ListCount - 1
                            lstOutput.Refresh
                        End If
                    Loop Until iPrime = 0
                Next
                txtTime.Text = timeGetTime() - ms
                txtPrimes.Text = siv.Primes
            Else
                ' Get all at once
                ms = timeGetTime()
                For i = 1 To cIter
                    ReDim ai(0 To 0)    ' Zero array
                    ReDim ai(0 To cPrime)
                    siv.AllPrimes ai()
                    If fDisplay Then
                        For iPrime = 0 To siv.Primes - 1
                            lstOutput.AddItem ai(iPrime)
                        Next
                    End If
                Next
                txtTime.Text = timeGetTime() - ms
                txtPrimes.Text = siv.Primes
            End If
        Case ordBasicDll
#If Win32 Then
            ' Basic DLL version, early bind
            ' (16-bit is an EXE that acts like a DLL)
            Dim sivD As New CDSieve
            sivD.MaxPrime = txtMaxPrime.Text
            If chkAll = vbUnchecked Then
                ' Get one at a time
                ms = timeGetTime()
                For i = 1 To cIter
                    sivD.ReInitialize
                    Do
                        iPrime = sivD.NextPrime
                        If fDisplay And iPrime Then
                            lstOutput.AddItem iPrime
                            lstOutput.TopIndex = lstOutput.ListCount - 1
                            lstOutput.Refresh
                        End If
                    Loop Until iPrime = 0
                Next
                txtTime.Text = timeGetTime() - ms
                txtPrimes.Text = sivD.Primes
            Else
                ' Get all at once
                ms = timeGetTime()
                For i = 1 To cIter
                    ReDim ai(0 To 0)    ' Zero array
                    ReDim ai(0 To cPrime)
                    sivD.AllPrimes ai()
                    If fDisplay Then
                        For iPrime = 0 To sivD.Primes - 1
                            lstOutput.AddItem ai(iPrime)
                        Next
                    End If
                Next
                txtTime.Text = timeGetTime() - ms
                txtPrimes.Text = sivD.Primes
            End If
#End If
        Case ordCppDll
            Dim sivC As New CCSieve
            sivC.MaxPrime = txtMaxPrime.Text
            If chkAll = vbUnchecked Then
                ' Get one at a time
                ms = timeGetTime()
                For i = 1 To cIter
                    sivC.ReInitialize
                    Do
                        iPrime = sivC.NextPrime
                        If fDisplay And iPrime Then
                            lstOutput.AddItem iPrime
                            lstOutput.TopIndex = lstOutput.ListCount - 1
                            lstOutput.Refresh
                        End If
                    Loop Until iPrime = 0
                Next
                txtTime.Text = timeGetTime() - ms
                txtPrimes.Text = sivC.Primes
            Else
                ' Get all at once
                ms = timeGetTime()
                For i = 1 To cIter
                    ReDim ai(0 To 0)    ' Zero array
                    ReDim ai(0 To cPrime)
                    sivC.AllPrimes ai()
                    If fDisplay Then
                        For iPrime = 0 To sivC.Primes - 1
                            lstOutput.AddItem ai(iPrime)
                        Next
                    End If
                Next
                txtTime.Text = timeGetTime() - ms
                txtPrimes.Text = sivC.Primes
            End If
        End Select
    Else ' Late bound
        ' Set reference variable
        ''@B OldCSieve
        Dim rsiv As Object
        Select Case cboServer.ListIndex
        Case ordBasicEXE
            Set rsiv = CreateObject("SieveServerEXE.CSieve")
        ''@E OldCSieve...
        Case ordBasicDll
#If Win32 Then
            Set rsiv = CreateObject("SieveServerDLL.CDSieve")
#End If
        Case ordCppDll
            Set rsiv = New CCSieve
            'Set rsiv = CreateObject("SieveSrvCpp.CCSieve")
        End Select
        rsiv.MaxPrime = txtMaxPrime.Text
        If chkAll = vbUnchecked Then
            ' Get one at a time
            ms = timeGetTime()
            For i = 1 To cIter
                rsiv.ReInitialize
                Do
                    iPrime = rsiv.NextPrime
                    If fDisplay And iPrime Then
                        lstOutput.AddItem iPrime
                        lstOutput.TopIndex = lstOutput.ListCount - 1
                        lstOutput.Refresh
                    End If
                Loop Until iPrime = 0
            Next
            txtTime.Text = timeGetTime() - ms
            txtPrimes.Text = rsiv.Primes
        Else
            ' Get all at once
            ms = timeGetTime()
            For i = 1 To cIter
                ReDim ai(0 To 0)    ' Zero array
                ReDim ai(0 To cPrime)
                rsiv.AllPrimes ai()
                If fDisplay Then
                    For iPrime = 0 To rsiv.Primes - 1
                        lstOutput.AddItem ai(iPrime)
                    Next
                End If
            Next
            txtTime.Text = timeGetTime() - ms
            txtPrimes.Text = rsiv.Primes
        End If
    End If
    MousePointer = ordMouse
End Sub

Sub RefreshControls()
    fDisplay = (chkDisplay.Value = vbChecked)
    If lstOutput.ListCount Then lstOutput.Clear
End Sub
