VERSION 4.00
Begin VB.Form FTimeIt 
   Caption         =   "Time It"
   ClientHeight    =   4965
   ClientLeft      =   1260
   ClientTop       =   1680
   ClientWidth     =   8550
   BeginProperty Font 
      name            =   "MS Sans Serif"
      charset         =   0
      weight          =   700
      size            =   8.25
      underline       =   0   'False
      italic          =   0   'False
      strikethrough   =   0   'False
   EndProperty
   Height          =   5370
   Left            =   1200
   LinkTopic       =   "Form1"
   ScaleHeight     =   4965
   ScaleWidth      =   8550
   Top             =   1335
   Width           =   8670
   Begin VB.TextBox txtIteration 
      Height          =   495
      Left            =   105
      TabIndex        =   5
      Top             =   1665
      Width           =   1575
   End
   Begin VB.ListBox lstProblems 
      Height          =   1980
      Left            =   120
      TabIndex        =   3
      Top             =   2595
      Width           =   3135
   End
   Begin VB.CommandButton cmdTimeIt 
      Caption         =   "&Time It"
      Default         =   -1  'True
      Height          =   495
      Left            =   150
      TabIndex        =   2
      Top             =   105
      Width           =   1215
   End
   Begin VB.CommandButton cmdExit 
      Cancel          =   -1  'True
      Caption         =   "E&xit"
      Height          =   495
      Left            =   150
      TabIndex        =   0
      Top             =   705
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "Problems:"
      Height          =   255
      Left            =   105
      TabIndex        =   7
      Top             =   2265
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Iterations:"
      Height          =   255
      Left            =   105
      TabIndex        =   6
      Top             =   1425
      Width           =   1215
   End
   Begin VB.Label lblDescription 
      Height          =   645
      Left            =   3405
      TabIndex        =   4
      Top             =   150
      UseMnemonic     =   0   'False
      Width           =   4965
   End
   Begin VB.Label lblOutput 
      Height          =   3795
      Left            =   3405
      TabIndex        =   1
      Top             =   990
      Width           =   4950
   End
End
Attribute VB_Name = "FTimeIt"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

''@B nProblems
Private nProblems As New Collection
''@E nProblems
''@B rprob
Private rprob As CProblem
''@E rprob

    ''@B ProbConst
Const sLogicalAndVsNestedIf = "Logical And Versus Nested If"
Const sByValVsByRef = "By Value Versus By Reference"
    ''@E ProbConst...
Const sDimNestedLevels = "Nested Dim Statements"
Const sCompareTypeProcessing = "Processing Different Types"
Const sInlineVsFunction = "Inline Versus Procedure"
Const sCompareLoWords = "LoWord Variations"
Const sCShiftVsBShift = "Shift Versus Multiply or Divide"
Const sIIfVsIfThen = "IIf Versus If/Then/Else"
Const sDollarVsNone = "String Versus Variant Functions"
Const sEmptyVsQuotes = "Empty Versus Blank String"
Const sWithWithout = "Object Access Using With"
Const sObjectVsProc = "Objects Versus Procedures"
Const sPlusVsAmpersand = "Concatenation With + and &"
Const sForEachVsForI = "For Each Versus For Index"
Const sSortCollectVsArray = "Shuffle, Sort, and Search"
Const sAddCollect = "Add To Collection"
Const sSortNameVsSortPoly = "Compare Sorting Methods"
Const sCompareFindFiles = "Compare File Finding Methods"

Private Sub Form_Load()
    Randomize
    ChDir CurDir$
    txtIteration.Locked = False
          
    ''@B SetProblem
    Set rprob = New CProblem
    rprob.Title = sLogicalAndVsNestedIf
    rprob.Description = _
        "Does Basic short-circuit logical expressions? " & _
        "Or does a logical And operation take the " & _
        "same time as an equivalent nested If/Then?"
    rprob.Iterations = 30000&
    nProblems.Add rprob, rprob.Title

    Set rprob = New CProblem
    rprob.Title = sByValVsByRef
    ''@E SetProblem...
    rprob.Description = _
        "How does the timing of ByVal arguments compare " & _
        "to the timing of the default By Reference arguments?"
    rprob.Iterations = 60000
    nProblems.Add rprob, rprob.Title

    Set rprob = New CProblem
    rprob.Title = sDimNestedLevels
    rprob.Description = _
        "Do Dim statements take measurable time that " & _
        "varies according to whether the statements " & _
        "are executed within loops and conditionals?"
    rprob.Iterations = 30000
    nProblems.Add rprob, rprob.Title

    Set rprob = New CProblem
    rprob.Description = _
        "Compare counting with different types: Integer, " & _
        "Long, Single, Double, Currency, and Variant"
    rprob.Title = sCompareTypeProcessing
    rprob.Iterations = 500
    nProblems.Add rprob, rprob.Title

    Set rprob = New CProblem
    rprob.Title = sInlineVsFunction
    rprob.Description = _
        "Compare an operation inline with the same " & _
        "operation in a function."
    rprob.Iterations = 30000
    nProblems.Add rprob, rprob.Title

    Set rprob = New CProblem
    rprob.Title = sCompareLoWords
    rprob.Description = _
        "Compare different methods of getting the low " & _
        "word of a long without getting overflow errors"
    rprob.Iterations = 5000
    nProblems.Add rprob, rprob.Title

    Set rprob = New CProblem
    rprob.Title = sCShiftVsBShift
    rprob.Description = _
        "Compare multiplication and division to shifting, " & _
        "both with C and with Basic"
    rprob.Iterations = 15000
    nProblems.Add rprob, rprob.Title

    Set rprob = New CProblem
    rprob.Title = sIIfVsIfThen
    rprob.Description = _
        "Is IIf faster than an equivalent If/Then/Else block?"
    rprob.Iterations = 30000
    nProblems.Add rprob, rprob.Title

    Set rprob = New CProblem
    rprob.Title = sDollarVsNone
    rprob.Description = _
        "Do Mid and Mid$ do exactly the same thing?"
    rprob.Iterations = 300
    nProblems.Add rprob, rprob.Title

    Set rprob = New CProblem
    rprob.Title = sEmptyVsQuotes
    rprob.Description = _
        "Compare testing various forms of empty strings including " & _
        "double quotes, sEmpty, Empty, and vbNullString."
    rprob.Iterations = 10000
    nProblems.Add rprob, rprob.Title

    Set rprob = New CProblem
    rprob.Title = sWithWithout
    rprob.Description = _
        "Compare object access using With to equivalent " & _
        "fully-specified object access when used both with " & _
        "object variables and reference object variables"
    rprob.Iterations = 3000
    nProblems.Add rprob, rprob.Title

    Set rprob = New CProblem
    rprob.Title = sObjectVsProc
    rprob.Description = _
        "Compare direct and indirect (using Set) object operations " & _
        "to comparable operations using procedures and variables."
    rprob.Iterations = 15000
    nProblems.Add rprob, rprob.Title

    Set rprob = New CProblem
    rprob.Title = sPlusVsAmpersand
    rprob.Description = _
        "Compare concatenation using the plus (+) operator to " & _
        "concatenation using the ampersand (&) operator."
    rprob.Iterations = 3000
    nProblems.Add rprob, rprob.Title

    Set rprob = New CProblem
    rprob.Title = sForEachVsForI
    rprob.Description = _
        "Compare iterating through various collections and arrays " & _
        "with For Each to iterating through with For using an index " & _
        "variable."
    rprob.Iterations = 60
    nProblems.Add rprob, rprob.Title

    Set rprob = New CProblem
    rprob.Title = sSortCollectVsArray
    rprob.Description = _
        "Compare filling, shuffling, sorting, and searching an " & _
        "array with the same operations on a collection."
    rprob.Iterations = 300
    nProblems.Add rprob, rprob.Title

    Set rprob = New CProblem
    rprob.Title = sAddCollect
    rprob.Description = _
        "Compare adding new items to a collection at the " & _
        "beginning, middle, and end"
    rprob.Iterations = 8000
    nProblems.Add rprob, rprob.Title
    
    Set rprob = New CProblem
    rprob.Title = sSortNameVsSortPoly
    rprob.Description = _
        "Compare faking procedure variabls with a name-space " & _
        "hack to faking them with a polymorphic class."
    rprob.Iterations = 200
    nProblems.Add rprob, rprob.Title
    
    Set rprob = New CProblem
    rprob.Title = sCompareFindFiles
    rprob.Description = _
        "Compare find files with Dir$, with Win32 FindFirstFiles, " & _
        "and with the Dir /S command."
    rprob.Iterations = 1
    nProblems.Add rprob, rprob.Title
    
    ''@B ListProblems
    For Each rprob In nProblems
        lstProblems.AddItem rprob.Title
    Next
    lstProblems.ListIndex = 0
    ''@E ListProblems

End Sub

Private Sub cmdTimeIt_Click()
    HourGlass Me
    lblOutput.Caption = "Working..."
    DoEvents
    Dim s As String, cIter As Long
    cIter = rprob.Iterations
    Select Case rprob.Title
    Case sLogicalAndVsNestedIf
        s = LogicalAndVsNestedIf(cIter)
    Case sByValVsByRef
        s = ByValVsByRef(cIter)
    Case sDimNestedLevels
        s = DimNestedLevels(cIter)
    Case sCompareTypeProcessing
        s = CompareTypeProcessing(cIter)
    Case sInlineVsFunction
        s = InlineVsFunction(cIter)
    Case sCompareLoWords
        s = CompareLoWords(cIter)
    Case sCShiftVsBShift
        s = CShiftVsBShift(cIter)
    Case sIIfVsIfThen
        s = IIfVsIfThen(cIter)
    Case sDollarVsNone
        s = DollarVsNone(cIter)
    Case sEmptyVsQuotes
        s = EmptyVsQuotes(cIter)
    Case sWithWithout
        s = WithWithout(cIter)
    Case sObjectVsProc
        s = ObjectVsProc(cIter)
    Case sPlusVsAmpersand
        s = PlusVsAmpersand(cIter)
    Case sForEachVsForI
        s = ForEachVsForI(cIter)
    Case sSortCollectVsArray
        s = SortCollectVsArray(cIter)
    Case sAddCollect
        s = AddCollect(cIter)
    Case sSortNameVsSortPoly
        s = SortNameVsSortPoly(cIter)
    Case sCompareFindFiles
        s = CompareFindFiles(cIter)
    End Select
    HourGlass Me
    BugMessage rprob.Description
    BugMessage "Iterations: " & rprob.Iterations
    BugMessage s
    lblOutput.Caption = s
End Sub

Private Sub cmdExit_Click()
    Unload Me
End Sub

Private Sub lstProblems_DblClick()
    cmdTimeIt_Click
End Sub


Private Sub txtIteration_Change()
    Dim i As Long
    i = Val(txtIteration.Text)
    If i Then
        rprob.Iterations = i
    Else
        Beep
        txtIteration.Text = rprob.Iterations
    End If
End Sub

Private Sub lstProblems_Click()
    Dim s As String
    ''@B LookupProblem
    s = lstProblems.List(lstProblems.ListIndex)
    Set rprob = nProblems(s)
    lblDescription.Caption = rprob.Description
    txtIteration.Text = rprob.Iterations
    ''@E LookupProblem
    'txtIteration.SetFocus
    txtIteration.SelStart = 0
    txtIteration.SelLength = Len(txtIteration.Text)

End Sub
