
#if !defined(WIN32)		// Already defined for Win32

#define ERROR_INVALID_HANDLE			6L     
#define ERROR_NOT_ENOUGH_MEMORY			8L    
#define ERROR_INVALID_PARAMETER         87L   
#define ERROR_BUFFER_OVERFLOW 			111L
#define ERROR_INVALID_DRIVE 	     	15L
#define ERROR_CALL_NOT_IMPLEMENTED  	120L
#define ERROR_BAD_PATHNAME		    	161L
#define ERROR_NOT_SUPPORTED				50L

#define INVALID_ROOT 100
#define NETWORK_PATH 101

#define DRIVE_UNKNOWN	0
#define DRIVE_NO_ROOT	1
#define DRIVE_REMOVABLE 2
#define DRIVE_FIXED 	3
#define DRIVE_REMOTE	4
#define DRIVE_CDROM 	5
#define DRIVE_RAMDISK	6

#endif

#if !defined(WIN32)		
UINT DLLAPI FlushFileBuffers(
	UINT hFile
    );
BOOL DLLAPI GetDiskFreeSpace(
	LPCSTR szRootPathName,
	LPDWORD lpSectorsPerCluster,
	LPDWORD lpBytesPerSector,
	LPDWORD lpNumberOfFreeClusters,
	LPDWORD lpTotalNumberOfClusters
	);            
UINT DLLAPI GetDriveTypeA(
	LPCSTR szRootPathName
	);
DWORD DLLAPI GetFullPathName(
    LPCSTR lpFileName,
	DWORD cbBuffer,
    LPSTR lpBuffer,
    LPSTR *lpFilePart
	);
DWORD DLLAPI GetLastError(
    VOID
	);
DWORD DLLAPI GetLogicalDrives(
    VOID
	);
DWORD DLLAPI GetLogicalDriveStrings(
	DWORD cchBuffer,
    LPSTR lpszBuffer
	);

UINT DLLAPI GetTempFileNameA(
    LPCSTR lpPathName,
    LPCSTR lpPrefixString,
    UINT uUnique,
    LPSTR lpTempFileName
    );
DWORD DLLAPI GetTempPath(
	DWORD cbBuffer,
    LPSTR lpBuffer
	);
DWORD DLLAPI SearchPath(
    LPCSTR lpPath,
    LPCSTR lpFileName,
    LPCSTR lpExtension,
	DWORD cbBuffer,
    LPSTR lpBuffer,
    LPSTR *lpFilePart
	);
VOID DLLAPI SetLastError(
	DWORD dwError
	);

// Helper routine
DWORD DLLAPI GetEnvironmentVariable(
	LPCSTR lpName,
	LPSTR lpBuffer,
	DWORD cbSize
	);
LPSTR DLLAPI GetEnv(
	LPCSTR lpName
	);
DWORD DLLAPI NormalizeDir(
    LPSTR lpBuffer,
	DWORD cbBuffer
	);

#endif // !WIN32
	
DWORD dwLastError;

// Helper routines	
int ValidateDiskDrive(
	LPCSTR szRootPathName
	);

BOOL IsFullPath(
	LPCSTR lpPathName
	);
	
unsigned ExistFilePath(
	LPSTR lpPath,
	LPCSTR lpFileName,
	LPSTR lpBuffer,
	DWORD cbBuffer, 
	LPSTR * lpFilePart);
                  
// Basic wrappers for Win32

BSTR DLLAPI GetFullPath(
    BSTR FAR * psFileName,
	LPDWORD lpdwFilePart,
	LPDWORD lpdwDirPart,
	LPDWORD lpdwExtPart
	);
BSTR DLLAPI SearchDirs(
    BSTR FAR * psPath,
    BSTR FAR * psFileName,
    BSTR FAR * psExtension,
	LPDWORD lpdwDirPart,
	LPDWORD lpdwFilePart,
	LPDWORD lpdwExtPart
	);
BSTR DLLAPI GetTempFile(
    BSTR FAR * psPathName,
	BSTR FAR * psPrefixString
	);
BSTR DLLAPI GetTempDir(
	void
	);

// Helper for Basic wrappers
void GetDirExt(
	LPSTR lpSpec, 
	LPDWORD lpdwDirPart,
	LPDWORD lpdwExtPart
	);

